####Function: mRNA ID transform(ENSEMBL to ENTREZ)####
Trans = function(Data)
{
  library(mygene)
  library(stringr)
  ensids = rownames(Data)
  ensids_temp = str_sub(ensids,1,15)
  id_ccle = queryMany(ensids_temp, scopes="ensembl.gene", fields="entrezgene", species="human")
 
  write.table(id_ccle,file = "E:/cell line pan-cancer/data/3ID transformed/id_mRNA.txt",sep = "\t",quote = F,row.names = F,col.names = T)
  id_ccle = as.data.frame(read.table(file = "E:/cell line pan-cancer/data/3ID transformed/id_mRNA.txt",header = T,row.names = NULL,check.names = F,sep="\t",stringsAsFactors = F))
  
  index_mRNA = duplicated(id_ccle$query)
  id_ccle = id_ccle[!index_mRNA,]
  id_ccle = as.matrix(id_ccle)
 
  Data = cbind(ensids_temp,Data)
  
  Data = cbind(id_ccle, Data)
  Data = Data[,-c(1:3,5,6)]
  Data = na.omit(Data)

  Data = as.data.frame(Data)
  Data = Data[!duplicated(Data$entrezgene),]
  
  return(Data)
}

####Main####
####Read omics data####

####Transform ID####
mRNA_temp = Trans(mRNA_temp)

####Write the preprocessed data####
