library(pheatmap)
library(RColorBrewer)

####Function: Combine all cluster term with qvalue####
combine = function(C1,C2,C3,C4,C5,C6,C7,C8,C9,C10,C11,C12,C13,C14,C15,C16,C17,C18)
{
  #Reduce(union, list(C1[,1],C2[,1],C3[,1],C4[,1],C5[,1],C6[,1],C7[,1],C8[,1],C9[,1],C10[,1],C11[,1],C12[,1],C13[,1],C14[,1],C15[,1],C16[,1],C17[,1],C18[,1]))
  Data = matrix(0,nrow = length(Reduce(union, list(C1[,1],C2[,1],C3[,1],C4[,1],C5[,1],C6[,1],C7[,1],C8[,1],C9[,1],C10[,1],C11[,1],C12[,1],C13[,1],C14[,1],C15[,1],C16[,1],C17[,1],C18[,1]))),ncol = 19)
  Data[,1]= Reduce(union, list(C1[,1],C2[,1],C3[,1],C4[,1],C5[,1],C6[,1],C7[,1],C8[,1],C9[,1],C10[,1],C11[,1],C12[,1],C13[,1],C14[,1],C15[,1],C16[,1],C17[,1],C18[,1]))
  for (i in 1:length(Reduce(union, list(C1[,1],C2[,1],C3[,1],C4[,1],C5[,1],C6[,1],C7[,1],C8[,1],C9[,1],C10[,1],C11[,1],C12[,1],C13[,1],C14[,1],C15[,1],C16[,1],C17[,1],C18[,1]))))
  {
    print(i)
    if(Data[i,1] %in% C1[,1])
    {
      Data[i,2] = C1[which(C1[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C2[,1])
    {
      Data[i,3] = C2[which(C2[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C3[,1])
    {
      Data[i,4] = C3[which(C3[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C4[,1])
    {
      Data[i,5] = C4[which(C4[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C5[,1])
    {
      Data[i,6] = C5[which(C5[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C6[,1])
    {
      Data[i,7] = C6[which(C6[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C7[,1])
    {
      Data[i,8] = C7[which(C7[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C8[,1])
    {
      Data[i,9] = C8[which(C8[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C9[,1])
    {
      Data[i,10] = C9[which(C9[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C10[,1])
    {
      Data[i,11] = C10[which(C10[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C11[,1])
    {
      Data[i,12] = C11[which(C11[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C12[,1])
    {
      Data[i,13] = C12[which(C12[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C13[,1])
    {
      Data[i,14] = C13[which(C13[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C14[,1])
    {
      Data[i,15] = C14[which(C14[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C15[,1])
    {
      Data[i,16] = C15[which(C15[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C16[,1])
    {
      Data[i,17] = C16[which(C16[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C17[,1])
    {
      Data[i,18] = C17[which(C17[,1]==Data[i,1]),2]
    }
    if(Data[i,1] %in% C18[,1])
    {
      Data[i,19] = C18[which(C18[,1]==Data[i,1]),2]
    }
  }
  colnames(Data)=c("Term","cluster1","cluster2","cluster3","cluster4","cluster5","cluster6","cluster7","cluster8","cluster9","cluster10","cluster11","cluster12","cluster13","cluster14","cluster15","cluster16","cluster17","cluster18")
  return(Data)
}


####Main####
####Read GO_BP_down enrichment data####

C1_BP_down = C1_BP_down[,c(2,7)]
C2_BP_down = C2_BP_down[,c(2,7)]
C3_BP_down = C3_BP_down[,c(2,7)]
C4_BP_down = C4_BP_down[,c(2,7)]
C5_BP_down = C5_BP_down[,c(2,7)]
C6_BP_down = C6_BP_down[,c(2,7)]
C7_BP_down = C7_BP_down[,c(2,7)]
C8_BP_down = C8_BP_down[,c(2,7)]
C9_BP_down = C9_BP_down[,c(2,7)]
C10_BP_down = C10_BP_down[,c(2,7)]
C11_BP_down = C11_BP_down[,c(2,7)]
C12_BP_down = C12_BP_down[,c(2,7)]
C13_BP_down = C13_BP_down[,c(2,7)]
C14_BP_down = C14_BP_down[,c(2,7)]
C15_BP_down = C15_BP_down[,c(2,7)]
C16_BP_down = C16_BP_down[,c(2,7)]
C17_BP_down = C17_BP_down[,c(2,7)]
C18_BP_down = C18_BP_down[,c(2,7)]

####GO_BP_down heatmap####
ALL_BP_down = combine(C1_BP_down,C2_BP_down,C3_BP_down,C4_BP_down,C5_BP_down,C6_BP_down,C7_BP_down,C8_BP_down,C9_BP_down,C10_BP_down,C11_BP_down,C12_BP_down,C13_BP_down,C14_BP_down,C15_BP_down,C16_BP_down,C17_BP_down,C18_BP_down)
rows_BP_down = ALL_BP_down[,1]
ALL_BP_down = ALL_BP_down[,-1]
ALL_BP_down = apply(ALL_BP_down,2,as.numeric) 
rownames(ALL_BP_down) = rows_BP_down
ALL_BP_down = -log10(ALL_BP_down) 
ALL_BP_down[is.infinite(ALL_BP_down)] = 0 
ALL_BP_down[which(ALL_BP_down<2)]=0
ALL_BP_down = ALL_BP_down[-which(rowSums(ALL_BP_down)==0),]
ALL_BP_down[which(ALL_BP_down>5)]=5 
#heatmap
pheatmap(ALL_BP_down,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,show_rownames = F,
         main = "GO BP downregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)

####Read GO_BP_up enrichment data####

C1_BP_up = C1_BP_up[,c(2,7)]
C2_BP_up = C2_BP_up[,c(2,7)]
C3_BP_up = C3_BP_up[,c(2,7)]
C4_BP_up = C4_BP_up[,c(2,7)]
C5_BP_up = C5_BP_up[,c(2,7)]
C6_BP_up = C6_BP_up[,c(2,7)]
C7_BP_up = C7_BP_up[,c(2,7)]
C8_BP_up = C8_BP_up[,c(2,7)]
C9_BP_up = C9_BP_up[,c(2,7)]
C10_BP_up = C10_BP_up[,c(2,7)]
C11_BP_up = C11_BP_up[,c(2,7)]
C12_BP_up = C12_BP_up[,c(2,7)]
C13_BP_up = C13_BP_up[,c(2,7)]
C14_BP_up = C14_BP_up[,c(2,7)]
C15_BP_up = C15_BP_up[,c(2,7)]
C16_BP_up = C16_BP_up[,c(2,7)]
C17_BP_up = C17_BP_up[,c(2,7)]
C18_BP_up = C18_BP_up[,c(2,7)]

####GO_BP_up heatmap####
ALL_BP_up = combine(C1_BP_up,C2_BP_up,C3_BP_up,C4_BP_up,C5_BP_up,C6_BP_up,C7_BP_up,C8_BP_up,C9_BP_up,C10_BP_up,C11_BP_up,C12_BP_up,C13_BP_up,C14_BP_up,C15_BP_up,C16_BP_up,C17_BP_up,C18_BP_up)
rows_BP_up = ALL_BP_up[,1]
ALL_BP_up = ALL_BP_up[,-1]
ALL_BP_up = apply(ALL_BP_up,2,as.numeric)
rownames(ALL_BP_up) = rows_BP_up
ALL_BP_up = -log10(ALL_BP_up)
ALL_BP_up[is.infinite(ALL_BP_up)] = 0 
ALL_BP_up[which(ALL_BP_up<2)]=0
ALL_BP_up = ALL_BP_up[-which(rowSums(ALL_BP_up)==0),]
ALL_BP_up[which(ALL_BP_up>5)]=5
#heatmap
pheatmap(ALL_BP_up,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,show_rownames = F,
         main = "GO BP upregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)


####Read GO_CC_down enrichment data####

C1_CC_down = C1_CC_down[,c(2,7)]
C2_CC_down = C2_CC_down[,c(2,7)]
C3_CC_down = C3_CC_down[,c(2,7)]
C4_CC_down = C4_CC_down[,c(2,7)]
C5_CC_down = C5_CC_down[,c(2,7)]
C6_CC_down = C6_CC_down[,c(2,7)]
C7_CC_down = C7_CC_down[,c(2,7)]
C8_CC_down = C8_CC_down[,c(2,7)]
C9_CC_down = C9_CC_down[,c(2,7)]
C10_CC_down = C10_CC_down[,c(2,7)]
C11_CC_down = C11_CC_down[,c(2,7)]
C12_CC_down = C12_CC_down[,c(2,7)]
C13_CC_down = C13_CC_down[,c(2,7)]
C14_CC_down = C14_CC_down[,c(2,7)]
C15_CC_down = C15_CC_down[,c(2,7)]
C16_CC_down = C16_CC_down[,c(2,7)]
C17_CC_down = C17_CC_down[,c(2,7)]
C18_CC_down = C18_CC_down[,c(2,7)]

####GO_CC_down heatmap####
ALL_CC_down = combine(C1_CC_down,C2_CC_down,C3_CC_down,C4_CC_down,C5_CC_down,C6_CC_down,C7_CC_down,C8_CC_down,C9_CC_down,C10_CC_down,C11_CC_down,C12_CC_down,C13_CC_down,C14_CC_down,C15_CC_down,C16_CC_down,C17_CC_down,C18_CC_down)
rows_CC_down = ALL_CC_down[,1]
ALL_CC_down = ALL_CC_down[,-1]
ALL_CC_down = apply(ALL_CC_down,2,as.numeric) 
rownames(ALL_CC_down) = rows_CC_down
ALL_CC_down = -log10(ALL_CC_down)
ALL_CC_down[is.infinite(ALL_CC_down)] = 0 
ALL_CC_down[which(ALL_CC_down<2)]=0
ALL_CC_down = ALL_CC_down[-which(rowSums(ALL_CC_down)==0),]
ALL_CC_down[which(ALL_CC_down>5)]=5 
#heatmap
pheatmap(ALL_CC_down,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,
         main = "GO CC downregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)

####Read GO_CC_up enrichment data####

C1_CC_up = C1_CC_up[,c(2,7)]
C2_CC_up = C2_CC_up[,c(2,7)]
C3_CC_up = C3_CC_up[,c(2,7)]
C4_CC_up = C4_CC_up[,c(2,7)]
C5_CC_up = C5_CC_up[,c(2,7)]
C6_CC_up = C6_CC_up[,c(2,7)]
C7_CC_up = C7_CC_up[,c(2,7)]
C8_CC_up = C8_CC_up[,c(2,7)]
C9_CC_up = C9_CC_up[,c(2,7)]
C10_CC_up = C10_CC_up[,c(2,7)]
C11_CC_up = C11_CC_up[,c(2,7)]
C12_CC_up = C12_CC_up[,c(2,7)]
C13_CC_up = C13_CC_up[,c(2,7)]
C14_CC_up = C14_CC_up[,c(2,7)]
C15_CC_up = C15_CC_up[,c(2,7)]
C16_CC_up = C16_CC_up[,c(2,7)]
C17_CC_up = C17_CC_up[,c(2,7)]
C18_CC_up = C18_CC_up[,c(2,7)]

####GO_CC_up heatmap####
ALL_CC_up = combine(C1_CC_up,C2_CC_up,C3_CC_up,C4_CC_up,C5_CC_up,C6_CC_up,C7_CC_up,C8_CC_up,C9_CC_up,C10_CC_up,C11_CC_up,C12_CC_up,C13_CC_up,C14_CC_up,C15_CC_up,C16_CC_up,C17_CC_up,C18_CC_up)
rows_CC_up = ALL_CC_up[,1]
ALL_CC_up = ALL_CC_up[,-1]
ALL_CC_up = apply(ALL_CC_up,2,as.numeric) 
rownames(ALL_CC_up) = rows_CC_up
ALL_CC_up = -log10(ALL_CC_up)
ALL_CC_up[is.infinite(ALL_CC_up)] = 0 
ALL_CC_up[which(ALL_CC_up<2)]=0
ALL_CC_up = ALL_CC_up[-which(rowSums(ALL_CC_up)==0),]
ALL_CC_up[which(ALL_CC_up>5)]=5 
#heatmap
pheatmap(ALL_CC_up,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,
         main = "GO CC upregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)


####Read GO_MF_down enrichment data####

C1_MF_down = C1_MF_down[,c(2,7)]
C2_MF_down = C2_MF_down[,c(2,7)]
C3_MF_down = C3_MF_down[,c(2,7)]
C4_MF_down = C4_MF_down[,c(2,7)]
C5_MF_down = C5_MF_down[,c(2,7)]
C6_MF_down = C6_MF_down[,c(2,7)]
C7_MF_down = C7_MF_down[,c(2,7)]
C8_MF_down = C8_MF_down[,c(2,7)]
C9_MF_down = C9_MF_down[,c(2,7)]
C10_MF_down = C10_MF_down[,c(2,7)]
C11_MF_down = C11_MF_down[,c(2,7)]
C12_MF_down = C12_MF_down[,c(2,7)]
C13_MF_down = C13_MF_down[,c(2,7)]
C14_MF_down = C14_MF_down[,c(2,7)]
C15_MF_down = C15_MF_down[,c(2,7)]
C16_MF_down = C16_MF_down[,c(2,7)]
C17_MF_down = C17_MF_down[,c(2,7)]
C18_MF_down = C18_MF_down[,c(2,7)]

####GO_MF_down heatmap####
ALL_MF_down = combine(C1_MF_down,C2_MF_down,C3_MF_down,C4_MF_down,C5_MF_down,C6_MF_down,C7_MF_down,C8_MF_down,C9_MF_down,C10_MF_down,C11_MF_down,C12_MF_down,C13_MF_down,C14_MF_down,C15_MF_down,C16_MF_down,C17_MF_down,C18_MF_down)
rows_MF_down = ALL_MF_down[,1]
ALL_MF_down = ALL_MF_down[,-1]
ALL_MF_down = apply(ALL_MF_down,2,as.numeric) 
rownames(ALL_MF_down) = rows_MF_down
ALL_MF_down = -log10(ALL_MF_down)
ALL_MF_down[is.infinite(ALL_MF_down)] = 0 
ALL_MF_down[which(ALL_MF_down<2)]=0
ALL_MF_down = ALL_MF_down[-which(rowSums(ALL_MF_down)==0),]
ALL_MF_down[which(ALL_MF_down>5)]=5 
#heatmap
pheatmap(ALL_MF_down,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,
         main = "GO MF downregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)

####Read GO_MF_up enrichment data####

C1_MF_up = C1_MF_up[,c(2,7)]
C2_MF_up = C2_MF_up[,c(2,7)]
C3_MF_up = C3_MF_up[,c(2,7)]
C4_MF_up = C4_MF_up[,c(2,7)]
C5_MF_up = C5_MF_up[,c(2,7)]
C6_MF_up = C6_MF_up[,c(2,7)]
C7_MF_up = C7_MF_up[,c(2,7)]
C8_MF_up = C8_MF_up[,c(2,7)]
C9_MF_up = C9_MF_up[,c(2,7)]
C10_MF_up = C10_MF_up[,c(2,7)]
C11_MF_up = C11_MF_up[,c(2,7)]
C12_MF_up = C12_MF_up[,c(2,7)]
C13_MF_up = C13_MF_up[,c(2,7)]
C14_MF_up = C14_MF_up[,c(2,7)]
C15_MF_up = C15_MF_up[,c(2,7)]
C16_MF_up = C16_MF_up[,c(2,7)]
C17_MF_up = C17_MF_up[,c(2,7)]
C18_MF_up = C18_MF_up[,c(2,7)]

####GO_MF_up heatmap####
ALL_MF_up = combine(C1_MF_up,C2_MF_up,C3_MF_up,C4_MF_up,C5_MF_up,C6_MF_up,C7_MF_up,C8_MF_up,C9_MF_up,C10_MF_up,C11_MF_up,C12_MF_up,C13_MF_up,C14_MF_up,C15_MF_up,C16_MF_up,C17_MF_up,C18_MF_up)
rows_MF_up = ALL_MF_up[,1]
ALL_MF_up = ALL_MF_up[,-1]
ALL_MF_up = apply(ALL_MF_up,2,as.numeric) 
rownames(ALL_MF_up) = rows_MF_up
ALL_MF_up = -log10(ALL_MF_up) 
ALL_MF_up[is.infinite(ALL_MF_up)] = 0 
ALL_MF_up[which(ALL_MF_up<2)]=0
ALL_MF_up = ALL_MF_up[-which(rowSums(ALL_MF_up)==0),]
ALL_MF_up[which(ALL_MF_up>5)]=5 
#heatmap
pheatmap(ALL_MF_up,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,
         main = "GO MF upregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)


####Read KEGG_down enrichment data####

C1_KEGG_down = C1_KEGG_down[,c(2,7)]
C2_KEGG_down = C2_KEGG_down[,c(2,7)]
C3_KEGG_down = C3_KEGG_down[,c(2,7)]
C4_KEGG_down = C4_KEGG_down[,c(2,7)]
C5_KEGG_down = C5_KEGG_down[,c(2,7)]
C6_KEGG_down = C6_KEGG_down[,c(2,7)]
C7_KEGG_down = C7_KEGG_down[,c(2,7)]
C8_KEGG_down = C8_KEGG_down[,c(2,7)]
C9_KEGG_down = C9_KEGG_down[,c(2,7)]
C10_KEGG_down = C10_KEGG_down[,c(2,7)]
C11_KEGG_down = C11_KEGG_down[,c(2,7)]
C12_KEGG_down = C12_KEGG_down[,c(2,7)]
C13_KEGG_down = C13_KEGG_down[,c(2,7)]
C14_KEGG_down = C14_KEGG_down[,c(2,7)]
C15_KEGG_down = C15_KEGG_down[,c(2,7)]
C16_KEGG_down = C16_KEGG_down[,c(2,7)]
C17_KEGG_down = C17_KEGG_down[,c(2,7)]
C18_KEGG_down = C18_KEGG_down[,c(2,7)]

####KEGG_down heatmap####
ALL_KEGG_down = combine(C1_KEGG_down,C2_KEGG_down,C3_KEGG_down,C4_KEGG_down,C5_KEGG_down,C6_KEGG_down,C7_KEGG_down,C8_KEGG_down,C9_KEGG_down,C10_KEGG_down,C11_KEGG_down,C12_KEGG_down,C13_KEGG_down,C14_KEGG_down,C15_KEGG_down,C16_KEGG_down,C17_KEGG_down,C18_KEGG_down)
rows_KEGG_down = ALL_KEGG_down[,1]
ALL_KEGG_down = ALL_KEGG_down[,-1]
ALL_KEGG_down = apply(ALL_KEGG_down,2,as.numeric)
rownames(ALL_KEGG_down) = rows_KEGG_down
ALL_KEGG_down = -log10(ALL_KEGG_down) 
ALL_KEGG_down[is.infinite(ALL_KEGG_down)] = 0 
ALL_KEGG_down[which(ALL_KEGG_down<2)]=0
ALL_KEGG_down = ALL_KEGG_down[-which(rowSums(ALL_KEGG_down)==0),]
ALL_KEGG_down[which(ALL_KEGG_down>5)]=5
#heatmap
pheatmap(ALL_KEGG_down,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,
         main = "KEGG downregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)

####Read KEGG_up enrichment data####

C1_KEGG_up = C1_KEGG_up[,c(2,7)]
C2_KEGG_up = C2_KEGG_up[,c(2,7)]
C3_KEGG_up = C3_KEGG_up[,c(2,7)]
C4_KEGG_up = C4_KEGG_up[,c(2,7)]
C5_KEGG_up = C5_KEGG_up[,c(2,7)]
C6_KEGG_up = C6_KEGG_up[,c(2,7)]
C7_KEGG_up = C7_KEGG_up[,c(2,7)]
C8_KEGG_up = C8_KEGG_up[,c(2,7)]
C9_KEGG_up = C9_KEGG_up[,c(2,7)]
C10_KEGG_up = C10_KEGG_up[,c(2,7)]
C11_KEGG_up = C11_KEGG_up[,c(2,7)]
C12_KEGG_up = C12_KEGG_up[,c(2,7)]
C13_KEGG_up = C13_KEGG_up[,c(2,7)]
C14_KEGG_up = C14_KEGG_up[,c(2,7)]
C15_KEGG_up = C15_KEGG_up[,c(2,7)]
C16_KEGG_up = C16_KEGG_up[,c(2,7)]
C17_KEGG_up = C17_KEGG_up[,c(2,7)]
C18_KEGG_up = C18_KEGG_up[,c(2,7)]

####KEGG_up heatmap####
ALL_KEGG_up = combine(C1_KEGG_up,C2_KEGG_up,C3_KEGG_up,C4_KEGG_up,C5_KEGG_up,C6_KEGG_up,C7_KEGG_up,C8_KEGG_up,C9_KEGG_up,C10_KEGG_up,C11_KEGG_up,C12_KEGG_up,C13_KEGG_up,C14_KEGG_up,C15_KEGG_up,C16_KEGG_up,C17_KEGG_up,C18_KEGG_up)
rows_KEGG_up = ALL_KEGG_up[,1]
ALL_KEGG_up = ALL_KEGG_up[,-1]
ALL_KEGG_up = apply(ALL_KEGG_up,2,as.numeric) 
rownames(ALL_KEGG_up) = rows_KEGG_up
ALL_KEGG_up = -log10(ALL_KEGG_up)
ALL_KEGG_up[is.infinite(ALL_KEGG_up)] = 0
ALL_KEGG_up[which(ALL_KEGG_up<2)]=0
ALL_KEGG_up = ALL_KEGG_up[-which(rowSums(ALL_KEGG_up)==0),]
ALL_KEGG_up[which(ALL_KEGG_up>5)]=5
#heatmap
pheatmap(ALL_KEGG_up,cluster_cols = F,cluster_rows = T,display_numbers = F,border_color = NA,
         main = "KEGG upregulated enrichment",angle_col=45,
         color = colorRampPalette(c("GhostWhite","firebrick3"))(1000),
         fontsize=10,fontsize_row=5,fontsize_col=10)
